import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.sql.ResultSet;

public class RiverHierarchy extends JApplet{
    public static void main(String[] args) {

        JFrame frame = new JFrame();
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("Jõed");
        JTree tree = new JTree(root);
        JScrollPane scrollPane = new JScrollPane(tree);

        tree.setShowsRootHandles(true);

        populateTree(root);

        frame.add(scrollPane);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(300,700);
        frame.setVisible(true);
    }

    /**
     *
     * @param root node
     */
    private static void populateTree(DefaultMutableTreeNode root){
        PSQLConnection psqlConnection = new PSQLConnection();
        ResultSet rs = psqlConnection.getResultSet("SELECT * FROM joe_andmed;");


        try{
            Integer j = 0;
            rs.last();
            Integer arraySize = rs.getRow();
            rs.first();

            Integer id_jogi[] = new Integer[arraySize];
            Integer id_peajogi[] = new Integer[arraySize];
            Integer id_suubla[] = new Integer[arraySize];
            String joenimi[] = new String[arraySize];

            while(rs.next()){
                joenimi[j] = rs.getString("joenimi");
                id_jogi[j] = rs.getInt("id_jogi");
                id_peajogi[j] = rs.getInt("id_peajogi");
                id_suubla[j] = rs.getInt("id_suubla");
                j++;

            }

            DefaultMutableTreeNode nodes[] = new DefaultMutableTreeNode[arraySize];
            for(int l=0; l<arraySize-1;l++){
                if(id_jogi[l].equals(id_peajogi[l])){       //kui jõgi on peajõgi
                    nodes[l] = new DefaultMutableTreeNode(joenimi[l]);
                    root.add(nodes[l]);
                }
                else{                                       //muul juhul tee node valmis
                    nodes[l] = new DefaultMutableTreeNode(joenimi[l]);
                }
            }
            for(int l=0; l<arraySize-1;l++){                //lisa alamjõed
                if(!id_jogi[l].equals(id_peajogi[l])) {
                    for(int m = 0; m<arraySize-1;m++){
                        if(id_jogi[m].equals(id_suubla[l])){
                            nodes[m].add(nodes[l]);
                        }

                    }
                }
            }

            rs.close();
           }catch (Exception e){
            e.printStackTrace();
        }
    }

}
